import re

class NumericRule(object):
    
    DOPERAND = {"<": ">", ">": "<"}
    
    def __init__(self, threshold, operand, invert=False):
        self._threshold = threshold
        self._operand = operand
    
    def __str__(self):
        return "%s%ibps" % (self._operand, self._threshold)
        #return "%s%i" % (self._operand, self._threshold)
    
    def compare(self, lNumericData):
        isAboveThreshold = False
        for value in lNumericData:
            exec("isAboveThreshold = %s %s %s" % (value, self._operand, self._threshold))
            if isAboveThreshold:
                return True
        return False
    
class PresenceRule(object):
    
    def __init__(self, pattern, invert=False):
        self._pattern = pattern
        self._invert = invert
        
    def compare(self, lPresenceData):
        isDataEquivalentToPattern = False
        for presenceData in lPresenceData:
            if re.search(self._pattern, presenceData):
                isDataEquivalentToPattern = True
                break
        if self._invert:
            return not isDataEquivalentToPattern
        return isDataEquivalentToPattern


class Condition(object):
    
    def __init__(self, lLengthRules=None, lPresenceRules=None, weight=0):
        self._lLengthRules = lLengthRules or []
        self._lPresenceRules = lPresenceRules or []
        self._weight = weight
        
    def getWeight(self):
        return self._weight
    
    def setWeight(self, weight):
        self._weight = weight
        
    def validate(self, lNumericData, lPresenceData=[]):
        for iLengthRule in self._lLengthRules:
            if not iLengthRule.compare(lNumericData):
                return False
        for iPresenceRule in self._lPresenceRules:
            if not iPresenceRule.compare(lPresenceData):
                return False
        return True