#!/usr/bin/env python

import user, os, sys, getopt

#------------------------------------------------------------------------------

def help():

    print "\nusage:",sys.argv[0],"[ options ]"
    print "options:"
    print "     -h: this help"
    print "     -p: project name"
    print "     -i: absolute path to the file recording the chunks (fasta)"
    print "     -T: table name to fill the gameXML files"
    print "     -t: tier name\n"

#------------------------------------------------------------------------------

def main():

    projectName = ""
    path2ChksFile = ""
    tableName = ""
    tierName = ""

    try:
        opts,args=getopt.getopt(sys.argv[1:],"hp:i:T:t:")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        if o == "-p":
            projectName = a
        if o == "-i":
            path2ChksFile = a
        if o == "-T":
            tableName = a
        if o == "-t":
            tierName = a

    if projectName == "" or path2ChksFile == "" or tableName == "" or tierName == "":
        print "*** Error: compulsory options are missing"
        help()
        sys.exit(1)

    if os.path.exists( projectName +  "_gameXML" ):
        print "*** Error: directory " + projectName +  "_gameXML already exists"
        sys.exit(1)

    if "/" not in path2ChksFile:
        chksFile = path2ChksFile
    else:
        chksFile = path2ChksFile.split("/")[-1]

    os.mkdir( projectName +  "_gameXML" )
    os.chdir( projectName +  "_gameXML" )

    os.mkdir( "src_gameXML" )
    os.chdir( "src_gameXML" )
    os.system( "ln -s " + path2ChksFile + " " + chksFile )

    cmd = "srptGameXmlMaker.py -f " + chksFile
    log = os.system( cmd )
    if log != 0:
        print "*** Error: srptGameXmlMaker.py returned " + str(log)
        sys.exit(1)

    os.system( "rename.sh gamexml.new gamexml.ori *.new" )
    os.system( "rm -f " + chksFile )
    os.chdir( ".." )
    os.system( "cp src_gameXML/*.ori ." )
    os.system( "rename.sh gamexml.ori gamexml *.ori" )

    tableFileName = "gameXML_table_file.txt"
    tableFile = open( tableFileName, "w" )
    tableFile.write( tierName + "\tpath\t" + tableName + "\n" )
    tableFile.close()

    files = os.popen( "ls *.gamexml" )
    files = files.read().split("\n")
    for f in files:
        if f != "":
            os.system( "srptGameXmlMaker.py -t " + tableFileName +\
                           " -g " + f )
    os.system( "rename.sh gamexml.new gamexml *.new" )

    return 0

#------------------------------------------------------------------------------

if __name__ == "__main__": 
    main ()
