#!/bin/bash
#----------------------------------------------------------------------------
help () {
    echo "USAGE: $0 [options] <multifasta file filename>"
    echo "options are:"
    echo "  -c : chunk size"
    echo "  -o : chunk overlap"
    echo "  -h : this help"
    exit 1;
}
#----------------------------------------------------------------------------
if [[ $# -eq 0 ]];
    then
	help;
    fi;

chunk_size=200000
overlap_size=10000
while  getopts "c:o:h" name $@;
do 
	if [[ $name == "c" ]]; then
		chunk_size=$OPTARG;
	fi;
	if [[ $name == "o" ]]; then
		overlap_size=$OPTARG;
	fi;
	if [[ $name == "h" ]]; then  
	    help;
	fi
done
let pos=$OPTIND-1
shift $pos
filename=$1
echo $filename

cutterDB -l $chunk_size -o $overlap_size -w 0 $filename
rm $filename.Nstretch.map

sed s/"^>"/">chunk"/ ${filename}_cut > ${filename}_cut.tmp

#grep ">" ${filename}_cut.tmp | sed s/">"// | sed s/"  "/\\t/ | sed s/" "\{Cut\}" "/\\t/ | sed s/"\.\."/\\t/ | sed s/\\t" "/\\t/ > ${filename}_chunk.map

# to make the "tab" or "\t", one does Ctrl+V followed by the TAB key
grep ">" ${filename}_cut.tmp | sed s/">"// | sed s/"  "/"	"/ | sed s/" "\{Cut\}" "/"	"/ | sed s/"\.\."/"	"/ | sed s/"	 "/"	"/ > ${filename}_chunk.map

awk '{print $1}' ${filename}_cut.tmp > ${filename}_chunk.fa

rm  ${filename}_cut.tmp ${filename}_cut
