#!/usr/bin/env bash

if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1

date

cd $root_dir/CombBLRrnd_$TElib_prefix

thresBLR=`awk '{print $8}' BLRn/*.align | sort -n | tail -1`
thresCEN=`awk '{print $8}' CEN/*.align | sort -n | tail -1`
thresRM=`awk '{print $8}' RM/*.align | sort -n | tail -1`

if [[ $thresBLR == '' ]]; then echo "*** Error: thresBLR empty !"; exit 1; fi;
if [[ $thresCEN == '' ]]; then echo "*** Error: thresCEN empty !"; exit 1; fi;
if [[ $thresRM == '' ]]; then echo "*** Error: thresRM empty !"; exit 1; fi;

echo "BLRn="$thresBLR
echo "CEN="$thresCEN
echo "RM="$thresRM

#thresBLR=68
#thresCEN=250
#thresRM=250

cd $root_dir/CombBLR_$TElib_prefix

rm -f Comb_${TElib_prefix}.tmp_path

#Blaster processing
awk -v thres=$thresBLR '$8>thres{print $0}' BLRn/BLR_${TElib_prefix}.BLRn.align > BLRnPval_${TElib_prefix}.BLRn.align

for i in ${chunk_dir}/chunk*.fa
do
  file=`echo $i | awk -F"/" '{print $(NF)}' `
  echo $file

  echo RepeatMasker processing
  ProcessRepeats RM/${file}.cat
  echo 1st awk
  RMout2path.awk RM/${file}.out > RM_${file}.path_tmp
  echo 2nd awk
  awk -v thres=$thresRM '$9>thres{print $0}' RM_${file}.path_tmp > RM_${file}.path
  rm RM_${file}.path_tmp
  echo 3rd awk
  path2align.awk RM_${file}.path > RM_${file}.align

  echo Censor processing
  echo 1st awk
  Cen2path.awk CEN/${file}.map > CEN_${file}.path_tmp
  echo 2nd awk
  awk -v thres=$thresCEN '$9>thres{print $0}' CEN_${file}.path_tmp > CEN_${file}.path
  rm CEN_${file}.path_tmp
  echo 3rd awk
  path2align.awk CEN_${file}.path > CEN_${file}.align

  #Combine
  chunk=`echo $file | awk -F"_" '{print $1}'`
  awk '$1==ch{print $0}' ch=$chunk BLRnPval_${TElib_prefix}.BLRn.align > BLRn_${file}.align
  matcher -m BLRn_${file}.align
  path2align.awk BLRn_${file}.align.clean_match.path > BLRn_${file}.align

  cat RM_${file}.align CEN_${file}.align BLRn_${file}.align > Comb_${file}.align
  matcher -m Comb_${file}.align -j

  cat Comb_${file}.align.clean_match.path >> Comb_${TElib_prefix}.tmp_path
done

pathnum2id.awk Comb_${TElib_prefix}.tmp_path > Comb_${TElib_prefix}.path
rm -f Comb_${TElib_prefix}.tmp_path

echo $0 " finished successfully !"
date
