#! /bin/bash


if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1

cdir=`pwd`

mkdir $chunk_dir
cd $chunk_dir

ln -s ../$genofile $genofile
chunkBuilder.sh -c 200000 -o 10000 $genofile
dbSplit.py -i $geno_db
rm $genofile
mv ${genofile}* ..

cd ..
srptCreateTable.py -f ${genofile}_chunk.fa -n $chunkSeqtable -t fasta
srptCreateTable.py -f ${genofile}_chunk.map -n $chunkMaptable -t map

cd $cdir
