#!/usr/bin/env python

import user, os, sys, getopt, exceptions

#-----------------------------------------------------------------------------

def help():

        print "\nusage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -i: input map file (output from Censor)"
	print "output file = <input file>.path"
	print "matchs on queries on direct or complement strand"
	print "matchs on subjects always on direct strand\n"

#-----------------------------------------------------------------------------

def main():

    inFileName = ""

    try:
        opts, args = getopt.getopt(sys.argv[1:],"hi:")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        if o == "-i":
            inFileName = a

    if inFileName == "":
        print "*** Error: missing input file name"
        help()
        sys.exit(1)

    dHSPs = {}
    outFile = open( inFileName + ".path", "w" )

    inFile = open( inFileName, "r" )
    line = inFile.readline()

    count = 1

    while 1:

        if line == "":
            break

        path = count
        count += 1

        line = line.split()

	qryName = line[0]
	strand = line[6]
	if strand == "d":   # if match with direct subject
	    qryStart = line[1]
	    qryEnd = line[2]
	elif strand == "c":   # if match with complement subject
	    qryStart = line[2]
	    qryEnd = line[1]

	sbjName = line[3]
	sbjStart = line[4]
	sbjEnd = line[5]
	if int(sbjStart) > int(sbjEnd):
	    print "*** Error: sbjStart > sbjEnd"
	    sys.exit(1)

	percId = 100 * float(line[7])
	score = int(line[9])

        data = str(path) + "\t" + qryName + "\t" + qryStart + "\t" + qryEnd
	data += "\t" + sbjName + "\t" + sbjStart + "\t" + sbjEnd + "\t0.0\t"
        data += str(score) + "\t" + str(percId) + "\n"

        outFile.write( data )

        line = inFile.readline()

    inFile.close()
    outFile.close()

    return 0

#-----------------------------------------------------------------------------

if __name__ == "__main__": 
    main ()
