#!/usr/bin/env python

import user, os, sys, getopt, exceptions

#-----------------------------------------------------------------------------

def help():

        print "\nusage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -i: input cat file (output from RMSSR)"
	print "output file = <input file>.align"
	print "matchs on queries on direct or complement strand"
	print "matchs on subjects always on direct strand"
	print "score is nb of identical sites\n"

#-----------------------------------------------------------------------------

def main():

    inFileName = ""

    try:
        opts, args = getopt.getopt(sys.argv[1:],"hi:")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        if o == "-i":
            inFileName = a

    if inFileName == "":
        print "*** Error: missing input file name"
        help()
        sys.exit(1)

    dHSPs = {}
    outFile = open( inFileName + ".path", "w" )

    inFile = open( inFileName, "r" )
    line = inFile.readline()

    count = 1

    while 1:

        if line == "":
            break

        line = line.split()
        try:
            test = int(line[0])
        except ValueError:
            break

        scoreSW = line[0]
	percDiv = line[1]
	percDel = line[2]
	percIns = line[3]
	qryName = line[4]

	if line[8] != "C":   # if match with direct subject
	    qryStart = line[5]
	    qryEnd = line[6]
	    sbjStart = line[9]
	    sbjEnd = line[10]

	elif line[8] == "C":   # if match with complement subject
	    qryStart = line[6]
	    qryEnd = line[5]
	    sbjStart = line[12]
	    sbjEnd = line[11]

	qryLeft = line[7]
	sbjName = line[9]

        percId = 100 - float(percDiv)

	# make the score comparable between RM, BLR and CEN
	if line[8] != "C":
	    score = int( (float(qryEnd) - float(qryStart) + 1) * percId / 100 )
	elif line[8] == "C":
	    score = int( (float(qryStart) - float(qryEnd) + 1) * percId / 100 )

        data = str(count) + "\t" + qryName + "\t" + qryStart + "\t" + qryEnd
	data +=  "\t" + sbjName + "\t" + sbjStart + "\t" + sbjEnd + "\t0.0\t"
        data += str(score) + "\t" + str(percId) + "\n"

        outFile.write( data )

        line = inFile.readline()
        count += 1

    inFile.close()
    outFile.close()

    return 0

#-----------------------------------------------------------------------------

if __name__ == "__main__": 
    main ()
