from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent
from PASTEC.Decision import Condition, NumericRule

class rDNAAdaptator_Agent(AbstractClassifierAgent):
    
    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents = ["rDNA_BLRn_Agent"]
        self.CONDITIONS = {"classif_other":  [Condition([NumericRule(self._environment.getMinrDNACoverage(), ">")]),
                                              Condition([NumericRule(self._environment.getMinrDNAIdentity(), ">")])],
                          "classif_BM":     [],
                          "weighting":      []}            
    
    def getAgentName(self):
        return "rDNA"

    def makeAppropriateConclusionsForrDNA_BLRn_Agent( self, iDemandAndResult ):
        if iDemandAndResult and iDemandAndResult.result:
            iBM = iDemandAndResult.result
            self._dNumericData["coverage"].append(iBM.getCoverage())
            self._dNumericData["identity"].append(iBM.getIdentity())
            self._conclusionsMatch.append({'rDNA': iBM})

    def decide(self):
        lOtherConditions = self.CONDITIONS["classif_other"]
        if self._dNumericData and "coverage" in self._dNumericData and "identity" in self._dNumericData:
            if self._dNumericData["coverage"] and self._dNumericData["identity"]:
                if lOtherConditions[0].validate([self._dNumericData["coverage"][0]]) and lOtherConditions[1].validate([self._dNumericData["identity"][0]]):
                    self._classification = self.getAgentName()
                    self._CI += 1
        
        normalizedIC = self._normalizeIC()
        return self._classification, normalizedIC
