#! /usr/bin/env python
from math import *
import biggles
from pyRepet.seq.AlignedBioseqDB import AlignedBioseqDB

class AlignedBioseqDBplotter(AlignedBioseqDB):
    
    def __init__(self):
        AlignedBioseqDB.__init__(self)
    
    def draw_align(self,title):
        frame=biggles.FramedPlot()
        frame.xlabel="$%s$"%"sequence"
        frame.ylabel="$%s$"%"names"
        frame.y1.ticklabels_style["fontsize"]=0.5
        frame.x.ticklabels_style["fontsize"]=0.5
        ylabel=[]
        data=[]
        for s in xrange(0,self.size()):
            start=-1
            end=-1
            lseg=[]
            BSseq=self.__getitem__(s).sequence
            BSname=self.__getitem__(s).header
            for i in xrange(0,self.length()):
                if BSseq[i]!='-':
                    end=i
                    if start==-1:
                        start=i
                else:
                    if start!=-1 and end!=-1:
                        lseg.append([start+1,end+1])
                    start=-1
                    end=-1

            if start!=-1 and end!=-1:
                lseg.append([start+1,end+1])
            data.append((BSname,lseg))
            data.sort()

        for i in data:
            ylabel.append(i[0])
        frame.y1.ticklabels=ylabel
        frame.y1.ticks=range(1,len(data)+1)
        frame.y1.draw_subticks=0
        frame.y2.ticks=range(1,len(data)+1)
        frame.y2.draw_subticks=0
        frame.title=title
        y=0
        for k in data:
            y=y+1
            for i in k[1]:
                if len(i)>2:
                    if i[2]>0:
                        seg=biggles.Curve(i[:2],[y,y],linewidth=5,\
                                          linetype="solid")
                        extL=biggles.Point(i[0],y,symboltype="|")
                        frame.add(extL)
                        extR=biggles.Point(i[1],y,\
                                           symboltype=">",\
                                           symbolesize=3)
                        frame.add(extR)
                    else:
                        seg=biggles.Curve(i[:2],[y,y],linewidth=5,\
                                          linetype="solid")
                        extL=biggles.Point(i[0],y,\
                                           symboltype="<",\
                                           symbolsize=3)
                        frame.add(extL)
                        extR=biggles.Point(i[1],y,symboltype="|")
                        frame.add(extR)
                else:
                    seg=biggles.Curve(i,[y,y],linewidth=5,linetype="solid")
                frame.add(seg)
        return frame

######################################################
#dessiner un graphe a partir d'une liste de valeurs y#
######################################################
    def __plot_curve(self,datax,datay,ylabel="",title=""):
        frame=biggles.FramedPlot()
        frame.title=title
        frame.xlabel="sequence"
        frame.ylabel=ylabel
        frame.x1.ticklabels_style["fontsize"]=0.5
        frame.add(biggles.Curve(datax,datay))
        return frame

    def draw_multigraph(self):
        datax=[]
        for x in xrange(0,self.length()):
            datax.append(x)
        frames=[]
        frames.append(self.draw_align("Sequences alignment"))
        frames.append(self.__plot_curve(datax,self.nbNuc(),"%of Nucleotides",""))
        frames.append(self.__plot_curve(datax,self.identity(),"%identity",""))
        frames.append(self.__plot_curve(datax,self.entropy(),"Entropy value",""))
       
        
        nb_frames=len(frames)
        table=biggles.Table(nb_frames,1)
        for i in xrange(0,nb_frames):
                      table[i,0]=frames[i]
        table.write_eps(self.name+'.eps')
   
